import loading
from loading import *

class Sonar:
    def __init__(self):
        self.pos = (525, 100)
        self.radius = 100
        self.sweep = 60
        self.emit_from = None
        self.blips = []
        self.blip_colors = ( (255,0,0),#red
                             (0,255,0),#green
                             (0,0,255))#blue

        self.players = []
        self.enemies = []
        self.neuts = []
        self.enemy_blink = 0
        self.enemy_do_blink = 100
        self.blink_for = 10
        self.on_blinking = 0
        self.rotate = 0.0

    def draw(self, surf):
        self.rotate += 0.05
        if self.rotate >  2 * math.pi:
            self.rotate -= 2 * math.pi

        obj = pygame.Surface((200,200))
        obj.fill([0,0,0])
        obj.set_colorkey(obj.get_at((0,0)), RLEACCEL)
        obj.set_alpha(150)
        r = pygame.draw.circle(obj, (34,139,34), (100,100), self.radius, 0)
        r2 = obj.get_rect()
        r2.center = self.pos
        surf.blit(obj, r2)
        for blip in self.blips:
            if blip[0] == "r":
                if self.enemy_blink >= self.enemy_do_blink:
                    self.on_blinking += 1
                    if self.on_blinking >= self.blink_for:
                        self.on_blinking = 0
                        self.enemy_blink = 0
                    r = pygame.rect.Rect(self.pos[0] + (blip[1] * 3 - 2), self.pos[1] + (blip[2] * 3 - 2), 5,5)
                    pygame.draw.rect(surf, self.blip_colors[0], r, 1)
                else:
                    pass
            elif blip[0] == "g":
                r = pygame.rect.Rect(self.pos[0] + (blip[1] * 3 - 2), self.pos[1] + (blip[2] * 3 - 2), 5,5)
                pygame.draw.rect(surf, self.blip_colors[1], r, 1)
            else:
                r = pygame.rect.Rect(self.pos[0] + (blip[1] * 3 - 2), self.pos[1] + (blip[2] * 3 - 2), 5,5)
                pygame.draw.rect(surf, self.blip_colors[2], r, 1)
        posx = self.pos[0] - math.cos(self.rotate) * 100
        posy = self.pos[1] - math.sin(self.rotate) * 100
        pygame.draw.line(surf, [255,255,255], self.pos, (posx,posy), 1)

    def sweep_map(self):
        self.enemy_blink += 1
        self.blips = []
        if self.emit_from == None:
            for enemy in self.enemies:
                if enemy.tile_x <= self.sweep:
                    if enemy.tile_y <= self.sweep:
                        self.blips.append(("r", enemy.tile_x, enemy.tile_y))
                    else:
                        pass
                else:
                    pass
            for neut in self.neuts:
                if neut.tile_x <= self.sweep:
                    if neut.tile_y <= self.sweep:
                        self.blips.append(("b", neut.tile_x, neut.tile_y))
                    else:
                        pass
                else:
                    pass
            for player in self.players:
                if player.tile_x <= self.sweep:
                    if player.tile_y <= self.sweep:
                        self.blips.append(("g", player.tile_x, player.tile_y))

        else:
            for enemy in self.enemies:
                t_x = int(enemy.rect.left/50)
                t_y = int(enemy.rect.top/50)
                if t_x >= self.emit_from[0] - self.sweep/2:
                    if t_x <= self.emit_from[0] + self.sweep/2:
                        if t_y >= self.emit_from[1] - self.sweep/2:
                            if t_y <= self.emit_from[1] + self.sweep/2:
                                self.blips.append(("r",t_x-self.emit_from[0],t_y-self.emit_from[1]))
                            else:pass
                        else:pass
                    else:pass
                else:pass
            for neut in self.neuts:
                t_x = int(neut.rect.left/50)
                t_y = int(neut.rect.top/50)
                if t_x >= self.emit_from[0] - self.sweep/2:
                    if t_x <= self.emit_from[0] + self.sweep/2:
                        if t_y >= self.emit_from[1] - self.sweep/2:
                            if t_y <= self.emit_from[1] + self.sweep/2:
                                self.blips.append(("b",t_x-self.emit_from[0],t_y-self.emit_from[1]))
                            else:pass
                        else:pass
                    else:pass
                else:pass
            for player in self.players:
                t_x = int(player.rect.left/50)
                t_y = int(player.rect.top/50)
                if t_x >= self.emit_from[0] - self.sweep/2:
                    if t_x <= self.emit_from[0] + self.sweep/2:
                        if t_y >= self.emit_from[1] - self.sweep/2:
                            if t_y <= self.emit_from[1] + self.sweep/2:
                                self.blips.append(("g",t_x-self.emit_from[0],t_y-self.emit_from[1]))
                            else:pass
                        else:pass
                    else:pass
                else:pass


    def sweep_from(self, loc):
        self.emit_from = loc

    def add_player(self, player):
        self.players.append(player)

    def add_enemy(self, enemy):
        self.enemies.append(enemy)

    def add_neut(self, neut):
        self.neuts.append(neut)

    def remove_player(self, player):
        self.players.remove(player)

    def remove_enemy(self, enemy):
        self.enemies.remove(enemy)

    def remove_neut(self, neut):
        self.neuts.remove(neut)
